Index: branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 790)
@@ -36,5 +36,5 @@
 
    INTERFACE trd_icp
-      MODULE PROCEDURE trd_2d, trd_3d
+      MODULE PROCEDURE trd_2d, trd_3d, trd_u2d, trd_u3d
    END INTERFACE
 
@@ -44,4 +44,19 @@
    PUBLIC   trd_icp_init  ! called by opa.F90
 
+   !! Variables used for diagnostics
+   REAL(wp) ::   tvolt        !: volume of the whole ocean computed at t-points
+   REAL(wp) ::   tvolu        !: volume of the whole ocean computed at u-points
+   REAL(wp) ::   tvolv        !: volume of the whole ocean computed at v-points
+
+   !! Active Tracer trend diagnostics variables
+   REAL(wp), DIMENSION(jpt_trd,2) ::   tsmo         !: tracers trends average 
+   REAL(wp), DIMENSION(jpt_trd,2) ::   ts2          !: tracers square trends average 
+
+   !! Momentum trends diagnostics variables
+   REAL(wp), DIMENSION(jptot_dyn) ::   umo, vmo         !: momentum trends average 
+   REAL(wp), DIMENSION(jptot_dyn) ::   hke              !: momentum square trends average 
+   REAL(wp) ::   rpktrd   !: potential to kinetic energy conversion
+   REAL(wp) ::   peke     !: conversion potential energy - kinetic energy trend
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -55,5 +70,5 @@
 CONTAINS
 
-   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype, clpas )
+   SUBROUTINE trd_2d( ptrd, ktra, ktrd , ctype, clpas )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_2d  ***
@@ -62,94 +77,167 @@
       !!              momentum equations at every time step frequency ntrd.
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   ptrd2dx             ! Temperature or U trend 
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   ptrd2dy             ! Salinity    or V trend
-      INTEGER                     , INTENT(in   ) ::   ktrd                ! tracer trend index
-      CHARACTER(len=3)            , INTENT(in   ) ::   ctype               ! momentum ('DYN') or tracers ('TRA') trends
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout)           ::   ptrd      ! tracer or u trend
+      INTEGER                     , INTENT(in   )           ::   ktra      ! tracer index
+      INTEGER                     , INTENT(in   )           ::   ktrd      ! tracer trend index
+      CHARACTER(len=3)            , INTENT(in   )           ::   ctype     ! tracer type (='TRA' or 'TRC')
       CHARACTER(len=3)            , INTENT(in   ), OPTIONAL ::   clpas     ! number of passage
       !!
-      INTEGER  ::   ji, jj                                                 ! loop indices
-      CHARACTER(len=3) ::   cpas                                           ! number of passage
-      REAL(wp) ::   zmsku, zbtu, zbt                                       ! temporary scalars
-      REAL(wp) ::   zmskv, zbtv                                            !    "         "
-      !!----------------------------------------------------------------------
-
-      ! Control of optional arguments
-      cpas = 'fst'
+      CHARACTER(len=3) ::   cpas   ! number of passage
+      REAL(wp)         ::   zsum   ! temporary scalars
+      !!----------------------------------------------------------------------
+
+      cpas = 'fst'                             ! Control of optional arguments
       IF( PRESENT(clpas) )  cpas = clpas
+
+      ! 1. Mask volumic trends
+      ptrd(:,:) = e1t(:,:) * e2t(:,:) * fse3t(:,:,1) * ptrd(:,:) * tmask_i(:,:)
+      
+      ! 2. Basin averaged tracer trends
+      SELECT CASE( ctype )
+      CASE( 'TRA' )              ! Tracers
+         zsum = SUM( ptrd(:,:) )
+         IF( cpas == 'fst' ) THEN   ;   tsmo(ktrd,ktra) =                   zsum
+         ELSE                       ;   tsmo(ktrd,ktra) = tsmo(ktrd,ktra) + zsum
+         ENDIF
+      CASE( 'TRC' )              ! Passive tracers
+         !      ....  to be done
+      END SELECT
+      
+      ! 3. Basin averaged tracer square trends (i.e. trd * now tracer field)
+      SELECT CASE( ctype )
+      CASE( 'TRA' )              ! Tracers
+         IF( ktra == jp_tem )   zsum = SUM(  ptrd(:,:) * tn(:,:,1) )
+         IF( ktra == jp_sal )   zsum = SUM(  ptrd(:,:) * sn(:,:,1) )
+         IF( cpas == 'fst' ) THEN   ;   ts2(ktrd,ktra) =                  zsum
+         ELSE                       ;   ts2(ktrd,ktra) = ts2(ktrd,ktra) + zsum
+         ENDIF
+      CASE( 'TRC' )              ! Passive tracers
+         !      ....  to be done
+      END SELECT
+      !
+   END SUBROUTINE trd_2d
+
+
+   SUBROUTINE trd_3d( ptrd, ktra, ktrd , ctype, clpas )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_3d  ***
+      !! 
+      !! ** Purpose : verify the basin averaged properties of tracers and/or
+      !!              momentum equations at every time step frequency ntrd.
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)           ::   ptrd      ! tracer or u trend
+      INTEGER                         , INTENT(in   )           ::   ktra      ! tracer index
+      INTEGER                         , INTENT(in   )           ::   ktrd      ! tracer trend index
+      CHARACTER(len=3)                , INTENT(in   )           ::   ctype     ! tracer type (='TRA' or 'TRC')
+      CHARACTER(len=3)                , INTENT(in   ), OPTIONAL ::   clpas     ! number of passage
+      !!
+      INTEGER          ::   jk     ! dummy loop indices
+      CHARACTER(len=3) ::   cpas   ! number of passage
+      REAL(wp)         ::   zsum   ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zsurf          ! 2D workspace array
+      !!----------------------------------------------------------------------
+
+      cpas = 'fst'                             ! Control of optional arguments
+      IF( PRESENT(clpas) )  cpas = clpas
+
+      ! 1. Mask volumic trends
+      zsurf(:,:) = e1t(:,:) * e2t(:,:) * tmask_i(:,:)
+      DO jk = 1, jpk
+         ptrd(:,:,jk) = zsurf(:,:) * fse3t(:,:,jk) * ptrd(:,:,jk) * tmask(:,:,jk)
+      END DO
+
+      ! 2. Basin averaged tracer trends
+      SELECT CASE( ctype )
+      CASE( 'TRA' )              ! Tracers
+         zsum = SUM( ptrd(:,:,:) )
+         IF( cpas == 'fst' ) THEN   ;   tsmo(ktrd,ktra) =                   zsum
+         ELSE                       ;   tsmo(ktrd,ktra) = tsmo(ktrd,ktra) + zsum
+         ENDIF
+      CASE( 'TRC' )              ! Passive tracers
+         !      ....  to be done
+      END SELECT
+
+      ! 3. Basin averaged tracer square trends (i.e. trd * now tracer field)
+      SELECT CASE( ctype )
+      CASE( 'TRA' )              ! Tracers
+         IF( ktra == jp_tem )   zsum = SUM(  ptrd(:,:,:) * tn(:,:,:) )
+         IF( ktra == jp_sal )   zsum = SUM(  ptrd(:,:,:) * sn(:,:,:) )
+         IF( cpas == 'fst' ) THEN   ;   ts2(ktrd,ktra) =                  zsum
+         ELSE                       ;   ts2(ktrd,ktra) = ts2(ktrd,ktra) + zsum
+         ENDIF
+      CASE( 'TRC' )              ! Passive tracers
+         !      ....  to be done
+      END SELECT
+      !
+   END SUBROUTINE trd_3d
+
+
+   SUBROUTINE trd_u2d( ptrdu, ptrdv, ktrd , ctype, clpas )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_2d  ***
+      !! 
+      !! ** Purpose : verify the basin averaged properties of tracers and/or
+      !!              momentum equations at every time step frequency ntrd.
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout)           ::   ptrdu, ptrdv   ! U and V momentum trends 
+      INTEGER                     , INTENT(in   )           ::   ktrd           ! tracer trend index
+      CHARACTER(len=3)            , INTENT(in   )           ::   ctype          ! momentum ('DYN')
+      CHARACTER(len=3)            , INTENT(in   ), OPTIONAL ::   clpas          ! number of passage
+      !!
+      INTEGER          ::   ji, jj        ! loop indices
+      CHARACTER(len=3) ::   cpas          ! number of passage
+      REAL(wp)         ::   zmsku, zbtu   ! temporary scalars
+      REAL(wp)         ::   zmskv, zbtv   !    "         "
+      !!----------------------------------------------------------------------
+
+      cpas = 'fst'                           ! Control of optional arguments
+      IF( PRESENT(clpas) )  cpas = clpas
+
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum
 
       ! 1. Mask trends
       ! --------------
-
-      SELECT CASE( ctype )
-      !
-      CASE( 'DYN' )              ! Momentum
-         DO jj = 1, jpjm1
-            DO ji = 1, jpim1
-               zmsku = tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,1)
-               zmskv = tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,1)
-               ptrd2dx(ji,jj) = ptrd2dx(ji,jj) * zmsku
-               ptrd2dy(ji,jj) = ptrd2dy(ji,jj) * zmskv
-            END DO
-         END DO
-         ptrd2dx(jpi, : ) = 0.e0      ;      ptrd2dy(jpi, : ) = 0.e0
-         ptrd2dx( : ,jpj) = 0.e0      ;      ptrd2dy( : ,jpj) = 0.e0
-         !
-      CASE( 'TRA' )              ! Tracers
-         ptrd2dx(:,:) = ptrd2dx(:,:) * tmask_i(:,:)
-         ptrd2dy(:,:) = ptrd2dy(:,:) * tmask_i(:,:)
-         !
-      END SELECT
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            zmsku = tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,1)
+            zmskv = tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,1)
+            ptrdu(ji,jj) = ptrdu(ji,jj) * zmsku
+            ptrdv(ji,jj) = ptrdv(ji,jj) * zmskv
+         END DO
+      END DO
+      ptrdu(jpi, : ) = 0.e0      ;      ptrdv(jpi, : ) = 0.e0
+      ptrdu( : ,jpj) = 0.e0      ;      ptrdv( : ,jpj) = 0.e0
       
       ! 2. Basin averaged tracer/momentum trends
       ! ----------------------------------------
-
-      SELECT CASE( ctype )
-      !
-      CASE( 'DYN' )              ! Momentum
-         umo(ktrd) = 0.e0
-         vmo(ktrd) = 0.e0
-         !
-         SELECT CASE( ktrd )
-         !
-         CASE( jpdyn_trd_swf )         ! surface forcing
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  umo(ktrd) = umo(ktrd) + ptrd2dx(ji,jj) * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,1)
-                  vmo(ktrd) = vmo(ktrd) + ptrd2dy(ji,jj) * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,1)
-               END DO
-            END DO
+      umo(ktrd) = 0.e0
+      vmo(ktrd) = 0.e0
+      !
+      SELECT CASE( ktrd )
+      !
+      CASE( jpdyn_trd_swf )         ! surface forcing
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               umo(ktrd) = umo(ktrd) + ptrdu(ji,jj) * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,1)
+               vmo(ktrd) = vmo(ktrd) + ptrdv(ji,jj) * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,1)
+            END DO
+         END DO
             !
          CASE( jpdyn_trd_bfr )         ! bottom friction fluxes
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  umo(ktrd) = umo(ktrd) + ptrd2dx(ji,jj)
-                  vmo(ktrd) = vmo(ktrd) + ptrd2dy(ji,jj)
+                  umo(ktrd) = umo(ktrd) + ptrdu(ji,jj)
+                  vmo(ktrd) = vmo(ktrd) + ptrdv(ji,jj)
                END DO
             END DO
             !
-         END SELECT
-         !
-      CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            tmo(ktrd) = 0.e0
-            smo(ktrd) = 0.e0
-         ENDIF
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zbt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,1)
-               tmo(ktrd) =  tmo(ktrd) + ptrd2dx(ji,jj) * zbt
-               smo(ktrd) =  smo(ktrd) + ptrd2dy(ji,jj) * zbt
-            END DO
-         END DO
-         !
       END SELECT
-      
+      !   
       ! 3. Basin averaged tracer/momentum square trends
       ! ----------------------------------------------
       ! c a u t i o n: field now
       
-      SELECT CASE( ctype )
-      !
-      CASE( 'DYN' )              ! Momentum
          hke(ktrd) = 0.e0
          DO jj = 1, jpj
@@ -157,29 +245,15 @@
                zbtu = e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,1)
                zbtv = e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,1)
-               hke(ktrd) = hke(ktrd)   &
-               &   + un(ji,jj,1) * ptrd2dx(ji,jj) * zbtu &
-               &   + vn(ji,jj,1) * ptrd2dy(ji,jj) * zbtv
+               hke(ktrd) = hke(ktrd) + un(ji,jj,1) * ptrdu(ji,jj) * zbtu   &
+               &                     + vn(ji,jj,1) * ptrdv(ji,jj) * zbtv
             END DO
          END DO
          !
-      CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            t2(ktrd) = 0.e0
-            s2(ktrd) = 0.e0
-         ENDIF
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zbt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,1)
-               t2(ktrd) = t2(ktrd) + ptrd2dx(ji,jj) * zbt * tn(ji,jj,1)
-               s2(ktrd) = s2(ktrd) + ptrd2dy(ji,jj) * zbt * sn(ji,jj,1)
-            END DO
-         END DO
-         !      
       END SELECT
       !
-   END SUBROUTINE trd_2d
-
-
-   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd, ctype, clpas )
+   END SUBROUTINE trd_u2d
+
+
+   SUBROUTINE trd_u3d( ptrdu, ptrdv, ktrd, ctype, clpas )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_3d  ***
@@ -188,25 +262,23 @@
       !!              momentum equations at every time step frequency ntrd.
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dx            ! Temperature or U trend 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dy            ! Salinity    or V trend
-      INTEGER,                          INTENT(in   ) ::   ktrd               ! momentum or tracer trend index
-      CHARACTER(len=3),                 INTENT(in   ) ::   ctype              ! momentum ('DYN') or tracers ('TRA') trends
-      CHARACTER(len=3),                 INTENT(in   ), OPTIONAL ::   clpas    ! number of passage
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)           ::   ptrdu, ptrdv   ! U and V momentum trends
+      INTEGER,                          INTENT(in   )           ::   ktrd           ! momentum trend index
+      CHARACTER(len=3),                 INTENT(in   )           ::   ctype          ! momentum (='DYN')
+      CHARACTER(len=3),                 INTENT(in   ), OPTIONAL ::   clpas          ! number of passage
       !!
       INTEGER ::   ji, jj, jk
-      CHARACTER(len=3) ::   cpas                                              ! number of passage
-      REAL(wp) ::   zbt, zbtu, zbtv, zmsku, zmskv                             ! temporary scalars
-      !!----------------------------------------------------------------------
-
-      ! Control of optional arguments
-      cpas = 'fst'
+      CHARACTER(len=3) ::   cpas               ! number of passage
+      REAL(wp) ::   zbtu, zbtv, zmsku, zmskv   ! temporary scalars
+      !!----------------------------------------------------------------------
+
+      cpas = 'fst'                            ! Control of optional arguments
       IF( PRESENT(clpas) )  cpas = clpas
 
-      ! 1. Mask the trends
-      ! ------------------
-
       SELECT CASE( ctype )
       !
       CASE( 'DYN' )              ! Momentum        
+
+         ! 1. Mask the trends
+         ! ------------------
          DO jk = 1, jpk
             DO jj = 1, jpjm1
@@ -214,26 +286,16 @@
                   zmsku = tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,jk)
                   zmskv = tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)
-                  ptrd3dx(ji,jj,jk) = ptrd3dx(ji,jj,jk) * zmsku
-                  ptrd3dy(ji,jj,jk) = ptrd3dy(ji,jj,jk) * zmskv
+                  ptrdu(ji,jj,jk) = ptrdu(ji,jj,jk) * zmsku
+                  ptrdv(ji,jj,jk) = ptrdv(ji,jj,jk) * zmskv
                END DO
             END DO
          END DO
-         ptrd3dx(jpi, : ,:) = 0.e0      ;      ptrd3dy(jpi, : ,:) = 0.e0
-         ptrd3dx( : ,jpj,:) = 0.e0      ;      ptrd3dy( : ,jpj,:) = 0.e0
+         ptrdu(jpi, : ,:) = 0.e0      ;      ptrdv(jpi, : ,:) = 0.e0
+         ptrdu( : ,jpj,:) = 0.e0      ;      ptrdv( : ,jpj,:) = 0.e0
          !
-      CASE( 'TRA' )              ! Tracers
-         DO jk = 1, jpk
-            ptrd3dx(:,:,jk) = ptrd3dx(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
-            ptrd3dy(:,:,jk) = ptrd3dy(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
-         END DO
-         !
-      END SELECT   
 
       ! 2. Basin averaged tracer/momentum trends
       ! ----------------------------------------
       
-      SELECT CASE( ctype )
-      !
-      CASE( 'DYN' )              ! Momentum
          umo(ktrd) = 0.e0
          vmo(ktrd) = 0.e0
@@ -243,26 +305,10 @@
                   zbtu = e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk)
                   zbtv = e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk)
-                  umo(ktrd) = umo(ktrd) + ptrd3dx(ji,jj,jk) * zbtu
-                  vmo(ktrd) = vmo(ktrd) + ptrd3dy(ji,jj,jk) * zbtv
+                  umo(ktrd) = umo(ktrd) + ptrdu(ji,jj,jk) * zbtu
+                  vmo(ktrd) = vmo(ktrd) + ptrdv(ji,jj,jk) * zbtv
                END DO
             END DO
          END DO
          !
-      CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            tmo(ktrd) = 0.e0
-            smo(ktrd) = 0.e0
-         ENDIF
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zbt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) 
-                  tmo(ktrd) =  tmo(ktrd) + ptrd3dx(ji,jj,jk) * zbt
-                  smo(ktrd) =  smo(ktrd) + ptrd3dy(ji,jj,jk) * zbt
-               END DO
-            END DO
-         END DO
-         !
-      END SELECT
 
       ! 3. Basin averaged tracer/momentum square trends
@@ -270,7 +316,4 @@
       ! c a u t i o n: field now
       
-      SELECT CASE( ctype )
-      !
-      CASE( 'DYN' )              ! Momentum
          hke(ktrd) = 0.e0
          DO jk = 1, jpk
@@ -279,22 +322,6 @@
                   zbtu = e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk)
                   zbtv = e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk)
-                  hke(ktrd) = hke(ktrd)   &
-                  &   + un(ji,jj,jk) * ptrd3dx(ji,jj,jk) * zbtu &
-                  &   + vn(ji,jj,jk) * ptrd3dy(ji,jj,jk) * zbtv
-               END DO
-            END DO
-         END DO
-         !
-      CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            t2(ktrd) = 0.e0
-            s2(ktrd) = 0.e0
-         ENDIF
-         DO jk = 1, jpk
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zbt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-                  t2(ktrd) = t2(ktrd) + ptrd3dx(ji,jj,jk) * zbt * tn(ji,jj,jk)
-                  s2(ktrd) = s2(ktrd) + ptrd3dy(ji,jj,jk) * zbt * sn(ji,jj,jk)
+                  hke(ktrd) = hke(ktrd) + un(ji,jj,jk) * ptrdu(ji,jj,jk) * zbtu   &
+                  &                     + vn(ji,jj,jk) * ptrdv(ji,jj,jk) * zbtv
                END DO
             END DO
@@ -303,6 +330,5 @@
       END SELECT
       !
-   END SUBROUTINE trd_3d
-
+   END SUBROUTINE trd_u3d
 
 
@@ -313,9 +339,10 @@
       !! ** Purpose :   Read the namtrd namelist
       !!----------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zmskt
+      INTEGER  ::   jk
 #if  defined key_trddyn
+      INTEGER  ::   ji, jj
       REAL(wp) ::   zmsku, zmskv
 #endif
+      REAL(wp), DIMENSION(jpi,jpj) ::   zsurf          ! 2D workspace array
       !!----------------------------------------------------------------------
 
@@ -328,11 +355,7 @@
       ! Total volume at t-points:
       tvolt = 0.e0
+      zsurf(:,:) = e1t(:,:) * e2t(:,:) * tmask_i(:,:)
       DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zmskt = tmask(ji,jj,jk) * tmask_i(ji,jj)
-               tvolt = tvolt + zmskt * e1t(ji,jj) *e2t(ji,jj) * fse3t(ji,jj,jk)
-            END DO
-         END DO
+            tvolt = tvolt + SUM( tmask(:,:,jk) * zsurf(:,:) * fse3t(:,:,jk) )
       END DO
       IF( lk_mpp )   CALL mpp_sum( tvolt )   ! sum over the global domain
@@ -379,5 +402,6 @@
       !!
       INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   ze1e2w, zcof, zbe1ru, zbe2rv, zbtr, ztz, zth   !    "      scalars
+      REAL(wp) ::   zcof, zbe1ru, zbe2rv, zbtr, ztz, zth   !    "      scalars
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zsurf          ! 2D workspace array
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zkepe, zkx, zky, zkz   ! temporary arrays
       !!----------------------------------------------------------------------
@@ -400,13 +424,10 @@
 
          ! Density flux at w-point
+         zsurf(:,:) = 0.5 * e1t(:,:) * e2t(:,:) * tmask_i(:,:) /rau0
+!!gm better use bn2....
+         zkz(:,:,1) = 0.e0
          DO jk = 2, jpk
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  ze1e2w = 0.5 * e1t(ji,jj) * e2t(ji,jj) * wn(ji,jj,jk) * tmask_i(ji,jj)
-                  zkz(ji,jj,jk) = ze1e2w / rau0 * ( rhop(ji,jj,jk) + rhop(ji,jj,jk-1) )
-               END DO
-            END DO
-         END DO
-         zkz(:,:,1) = 0.e0
+            zkz(:,:,jk) = zsurf(:,:) * wn(:,:,jk) * ( rhop(:,:,jk) + rhop(:,:,jk-1) )
+         END DO
          
          ! Density flux at u and v-points
@@ -588,8 +609,6 @@
          ! -------------------------------
          IF( lk_mpp ) THEN
-            CALL mpp_sum( tmo, jptot_tra )   
-            CALL mpp_sum( smo, jptot_tra )
-            CALL mpp_sum( t2 , jptot_tra )
-            CALL mpp_sum( s2 , jptot_tra )
+            CALL mpp_sum( tsmo, jpt_trd )   
+            CALL mpp_sum( ts2 , jpt_trd )
          ENDIF
 
@@ -601,21 +620,26 @@
             WRITE (numout,*)
             WRITE (numout,9400) kt
-            WRITE (numout,9401) (tmo(jpicpt_xad)+tmo(jpicpt_yad))/ tvolt, (smo(jpicpt_xad)+smo(jpicpt_yad))/ tvolt
-            WRITE (numout,9402)  tmo(jpicpt_zad) / tvolt, smo(jpicpt_zad) / tvolt
-            WRITE (numout,9403)  tmo(jpicpt_ldf) / tvolt, smo(jpicpt_ldf) / tvolt
-            WRITE (numout,9404)  tmo(jpicpt_zdf) / tvolt, smo(jpicpt_zdf) / tvolt
-            WRITE (numout,9405)  tmo(jpicpt_npc) / tvolt, smo(jpicpt_npc) / tvolt
-            WRITE (numout,9406)  tmo(jpicpt_dmp) / tvolt, smo(jpicpt_dmp) / tvolt
-            WRITE (numout,9407)  tmo(jpicpt_qsr) / tvolt
-            WRITE (numout,9408)  tmo(jpicpt_nsr) / tvolt, smo(jpicpt_nsr) / tvolt
+            WRITE (numout,9401) ( tsmo(jpt_trd_xad,jp_tem) + tsmo(jpt_trd_yad,jp_tem)  ) / tvolt,   &
+               &                ( tsmo(jpt_trd_xad,jp_sal) + tsmo(jpt_trd_yad,jp_sal)  ) / tvolt
+            WRITE (numout,9402)   tsmo(jpt_trd_zad,jp_tem) / tvolt,   tsmo(jpt_trd_zad,jp_sal) / tvolt
+            WRITE (numout,9403)   tsmo(jpt_trd_ldf,jp_tem) / tvolt,   tsmo(jpt_trd_ldf,jp_sal) / tvolt
+            WRITE (numout,9404)   tsmo(jpt_trd_zdf,jp_tem) / tvolt,   tsmo(jpt_trd_zdf,jp_sal) / tvolt
+            WRITE (numout,9405)   tsmo(jpt_trd_npc,jp_tem) / tvolt,   tsmo(jpt_trd_npc,jp_sal) / tvolt
+            WRITE (numout,9406)   tsmo(jpt_trd_dmp,jp_tem) / tvolt,   tsmo(jpt_trd_dmp,jp_sal) / tvolt
+            WRITE (numout,9407)   tsmo(jpt_trd_qsr,jp_tem) / tvolt
+            WRITE (numout,9408)   tsmo(jpt_trd_qns,jp_tem) / tvolt,   tsmo(jpt_trd_qns,jp_sal) / tvolt
             WRITE (numout,9409) 
-            WRITE (numout,9410) (  tmo(jpicpt_xad) + tmo(jpicpt_yad) + tmo(jpicpt_zad) + tmo(jpicpt_ldf) + tmo(jpicpt_zdf)   &
-            &                    + tmo(jpicpt_npc) + tmo(jpicpt_dmp) + tmo(jpicpt_qsr) + tmo(jpicpt_nsr) ) / tvolt,   &
-            &                   (  smo(jpicpt_xad) + smo(jpicpt_yad) + smo(jpicpt_zad) + smo(jpicpt_ldf) + smo(jpicpt_zdf)   &
-            &                    + smo(jpicpt_npc) + smo(jpicpt_dmp)                   + smo(jpicpt_nsr) ) / tvolt
-         ENDIF
-
-9400     FORMAT(' tracer trend at it= ',i6,' :     temperature',   &
-              '              salinity',/' ============================')
+            WRITE (numout,9410) (  tsmo(jpt_trd_xad,jp_tem) + tsmo(jpt_trd_yad,jp_tem) + tsmo(jpt_trd_zad,jp_tem)     &
+               &                 + tsmo(jpt_trd_ldf,jp_tem) + tsmo(jpt_trd_zdf,jp_tem) + tsmo(jpt_trd_npc,jp_tem)     &
+               &                 + tsmo(jpt_trd_dmp,jp_tem) + tsmo(jpt_trd_qsr,jp_tem) + tsmo(jpt_trd_qns,jp_tem) )   &
+               &                / tvolt,   &
+               &                (  tsmo(jpt_trd_xad,jp_sal) + tsmo(jpt_trd_yad,jp_sal) + tsmo(jpt_trd_zad,jp_sal)     &
+               &                 + tsmo(jpt_trd_ldf,jp_sal) + tsmo(jpt_trd_zdf,jp_sal) + tsmo(jpt_trd_npc,jp_sal)     &
+               &                 + tsmo(jpt_trd_dmp,jp_sal)                           + tsmo(jpt_trd_qns,jp_sal) )   &
+               &                / tvolt
+
+
+9400     FORMAT(' tracer trend at it= ',i6,' :     temperature              salinity', /,   &
+                ' ============================')
 9401     FORMAT(' horizontal advection        ',e20.13,'     ',e20.13)
 9402     FORMAT(' vertical advection          ',e20.13,'     ',e20.13)
@@ -630,25 +654,28 @@
 
 
-         IF(lwp) THEN
             WRITE (numout,*)
             WRITE (numout,*)
             WRITE (numout,9420) kt
-            WRITE (numout,9421) ( t2(jpicpt_xad)+t2(jpicpt_yad) )/ tvolt, ( s2(jpicpt_xad)+s2(jpicpt_yad) )/ tvolt
-            WRITE (numout,9422)   t2(jpicpt_zad) / tvolt, s2(jpicpt_zad) / tvolt
-            WRITE (numout,9423)   t2(jpicpt_ldf) / tvolt, s2(jpicpt_ldf) / tvolt
-            WRITE (numout,9424)   t2(jpicpt_zdf) / tvolt, s2(jpicpt_zdf) / tvolt
-            WRITE (numout,9425)   t2(jpicpt_npc) / tvolt, s2(jpicpt_npc) / tvolt
-            WRITE (numout,9426)   t2(jpicpt_dmp) / tvolt, s2(jpicpt_dmp) / tvolt
-            WRITE (numout,9427)   t2(jpicpt_qsr) / tvolt
-            WRITE (numout,9428)   t2(jpicpt_nsr) / tvolt, s2(jpicpt_nsr) / tvolt
+            WRITE (numout,9421) ( ts2(jpt_trd_xad,jp_tem) + ts2(jpt_trd_yad,jp_tem) ) / tvolt,   &
+               &                ( ts2(jpt_trd_xad,jp_sal) + ts2(jpt_trd_yad,jp_sal) ) / tvolt
+            WRITE (numout,9422)   ts2(jpt_trd_zad,jp_tem) / tvolt, ts2(jpt_trd_zad,jp_sal) / tvolt
+            WRITE (numout,9423)   ts2(jpt_trd_ldf,jp_tem) / tvolt, ts2(jpt_trd_ldf,jp_sal) / tvolt
+            WRITE (numout,9424)   ts2(jpt_trd_zdf,jp_tem) / tvolt, ts2(jpt_trd_zdf,jp_sal) / tvolt
+            WRITE (numout,9425)   ts2(jpt_trd_npc,jp_tem) / tvolt, ts2(jpt_trd_npc,jp_sal) / tvolt
+            WRITE (numout,9426)   ts2(jpt_trd_dmp,jp_tem) / tvolt, ts2(jpt_trd_dmp,jp_sal) / tvolt
+            WRITE (numout,9427)   ts2(jpt_trd_qsr,jp_tem) / tvolt
+            WRITE (numout,9428)   ts2(jpt_trd_qns,jp_tem) / tvolt, ts2(jpt_trd_qns,jp_sal) / tvolt
             WRITE (numout,9429)
-            WRITE (numout,9430) (  t2(jpicpt_xad) + t2(jpicpt_yad) + t2(jpicpt_zad) + t2(jpicpt_ldf) + t2(jpicpt_zdf)   &
-            &                    + t2(jpicpt_npc) + t2(jpicpt_dmp) + t2(jpicpt_qsr) + t2(jpicpt_nsr) ) / tvolt,   &
-            &                   (  s2(jpicpt_xad) + s2(jpicpt_yad) + s2(jpicpt_zad) + s2(jpicpt_ldf) + s2(jpicpt_zdf)   &
-            &                    + s2(jpicpt_npc) + s2(jpicpt_dmp)                  + s2(jpicpt_nsr) ) / tvolt
-         ENDIF
-
-9420     FORMAT(' tracer**2 trend at it= ', i6, ' :      temperature',   &
-            '               salinity', /, ' ===============================')
+            WRITE (numout,9430) (  ts2(jpt_trd_xad,jp_tem) + ts2(jpt_trd_yad,jp_tem) + ts2(jpt_trd_zad,jp_tem)     &
+               &                 + ts2(jpt_trd_ldf,jp_tem) + ts2(jpt_trd_zdf,jp_tem) + ts2(jpt_trd_npc,jp_tem)     &
+               &                 + ts2(jpt_trd_dmp,jp_tem) + ts2(jpt_trd_qsr,jp_tem) + ts2(jpt_trd_qns,jp_tem) )   &
+               &                / tvolt,   &
+               &                (  ts2(jpt_trd_xad,jp_sal) + ts2(jpt_trd_yad,jp_sal) + ts2(jpt_trd_zad,jp_sal)     &
+               &                 + ts2(jpt_trd_ldf,jp_sal) + ts2(jpt_trd_zdf,jp_sal) + ts2(jpt_trd_npc,jp_sal)     &
+               &                 + ts2(jpt_trd_dmp,jp_sal)                          + ts2(jpt_trd_qns,jp_sal) )   &
+               &                / tvolt
+
+9420     FORMAT(' tracer**2 trend at it= ',i6,' :     temperature              salinity', /,   &
+                ' ============================')
 9421     FORMAT(' horizontal advection      * t   ', e20.13, '     ', e20.13)
 9422     FORMAT(' vertical advection        * t   ', e20.13, '     ', e20.13)
